import java.net.*;
import com.interfaceware.chameleon.*;

public class XmlExample implements Log
{
   private static final String MESSAGE_DEFINITION_FILE = "project.vmd";

   private DynamicEngine m_engine;
   
   static public void main(String[] Args)
   {
      XmlExample Example = new XmlExample();
      Example.startExample();
   }

   public XmlExample() {}

   public void startExample()
   {
      try
      {
         m_engine = new DynamicEngine();
         m_engine.addLog(this);
         m_engine.load(MESSAGE_DEFINITION_FILE);

         println("We start with a flatwire message:");
         String FlatWire;
         FlatWire = "MSH|^~\\&|REGADT|MCM|RSP1P8|MCM|199601051530|SEC|ADT^A44|00000007|P|2.3\r";
         FlatWire = FlatWire + "EVN|A44|199601051530\r";
         FlatWire = FlatWire + "PID|||MR2^^^XYZ||JONES^WILLIAM^A^JR||19501010|M|||123 EAST STREET^^NY^NY^10021||(212)111-3333|||S||ACCT1\r";
         FlatWire = FlatWire + "MRG|MR1^^^XYZ||ACCT1\r";
         FlatWire = FlatWire + "MRG|MR1^^^XYZ||ACCT1\r";
         FlatWire = FlatWire + "MRG|MR1^^^XYZ||ACCT1\r";

         println(m_engine.makeMessagePrintable(FlatWire));
         
         String XmlFormat = m_engine.translateMessageToXml(FlatWire);
         
         println("Translating to XML.");
         println("Using the Standard Version 2 format:");
         println(XmlFormat);
         String Hl7 = m_engine.translateXmlToMessage(XmlFormat);
         println("And translating back again...");
         println(m_engine.makeMessagePrintable(Hl7));
         
         println("Press Enter to Exit...");
         System.in.read();
      }
      catch (ChameleonException err)
      {
         println(err.toString());
      }
      catch (java.io.IOException err)
      {
         println(err.toString());
      }
   }

   // Log interface

   public void println(String output_text)
   {
      System.out.println(output_text);		
   }
}
